<?php

namespace Teknisa\TCO\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class Tco01010RevisaoReceitaService extends \Teknisa\GER\Controllers\TeknisaCrud{
    
    protected $crudService;
    protected $environment;
    protected $entityManager;

    public function __construct($crudService, $parameterBag, $environment, $entityManager) {
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
    }
    
    public function getFilialParamTco(){
        $sql = "SELECT CDFILIAL FROM PARAMTCO";
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();
        return empty($result[0]['CDFILIAL']) ? "" : $result[0]['CDFILIAL'];
    }
    
    public function getFilialRece($row){
        $sql = "SELECT CDFILIAL, NMFILIAL FROM FILIAL WHERE CDFILIAL = (SELECT CDFILIAL FROM PARAMTCO) ";
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();
        $row['CDFILIAL'] = empty($result[0]['CDFILIAL']) ? "" : $result[0]['CDFILIAL'];
        $row['NMFILIAL'] = empty($result[0]['NMFILIAL']) ? "" : $result[0]['NMFILIAL'];
        return $row;
    }
    
    public function getServicoRece($row){
        $sql = "SELECT CDSERVFILI, NMSERVICO FROM SERVICO WHERE CDSERVFILI = :CDSERVFILI AND CDFILIAL =:CDFILIAL";
        $params = array(
            "CDSERVFILI" => $row["CDSERVFILI"],
            "CDFILIAL"   => $row['CDFILIAL']
        );
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $row['CDSERVFILI'] = empty($result[0]['CDSERVFILI']) ? "" : $result[0]['CDSERVFILI'];
        $row['NMSERVICO'] = empty($result[0]['NMSERVICO']) ? "" : $result[0]['NMSERVICO'];
        return $row;
    }
    
    public function getRegiaoRece($row){
        $sql = "SELECT CDREGIAO, NMREGIAO FROM REGIAO WHERE CDREGIAO = :CDREGIAO";
        $params = array(
            "CDREGIAO" => $row["CDREGIAO"]
        );
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $row['CDREGIAO'] = empty($result[0]['CDREGIAO']) ? "" : $result[0]['CDREGIAO'];
        $row['NMREGIAO'] = empty($result[0]['NMREGIAO']) ? "" : $result[0]['NMREGIAO'];
        return $row;
    }
    
    public function getPadQuaRece($row){
        $sql = "SELECT CDPADRAOQUALIDADE, NMPADRAOQUALIDADE FROM PADRAOQUALIDADE WHERE NRPADRAOQUALIDADE = :NRPADRAOQUALIDADE";
        $params = array(
            "NRPADRAOQUALIDADE" => $row["NRPADRAOQUALIDADE"]
        );
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $row['CDPADRAOQUALIDADE'] = empty($result[0]['CDPADRAOQUALIDADE']) ? "" : $result[0]['CDPADRAOQUALIDADE'];
        $row['NMPADRAOQUALIDADE'] = empty($result[0]['NMPADRAOQUALIDADE']) ? "" : $result[0]['NMPADRAOQUALIDADE'];
        return $row;
    }
    
    public function getReceUtil($row){
        $sql = "SELECT RECE_UTIL_TCO(:CDFILAUXPRAT, :CDPRATO, :CDFILIAL, :NRSERVICOPROPOSTA, :NRPADRAOQUALIDADE, :CDREGIAO, :NRCARDAPIOTRAB) AS RECEUTIL FROM DUAL";
        $params = array(
            "CDFILAUXPRAT"      => $row['CDFILAUXPRAT'],
            "CDPRATO"           => $row['CDPRATO'],
            "CDFILIAL"          => $row['CDFILIAL'],
            "NRSERVICOPROPOSTA" => $row['NRSERVICOPROPOSTA'],
            "NRPADRAOQUALIDADE" => $row["NRPADRAOQUALIDADE"],
            "CDREGIAO"          => !empty($row['CDREGIAO']) ? $row['CDREGIAO'] : null,
            "NRCARDAPIOTRAB"    => !empty($row['NRCARDAPIOTRAB']) ? $row['NRCARDAPIOTRAB'] : null
        );
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $row['RECEUTIL'] = empty($result[0]['RECEUTIL']) ? "" : $result[0]['RECEUTIL'];
        return $row;
    }
    
    public function deleteReceRegiao($row){
        $sql = "DELETE FROM RECEREGIAO WHERE CDFILAUXPRAT =:CDFILAUXPRAT AND CDPRATO =:CDPRATO AND CDREGIAO <> :CDREGIAO";
        $params = array(
            "CDFILAUXPRAT"      => $row['CDFILAUXPRAT'],
            "CDPRATO"           => $row['CDPRATO'],
            "CDREGIAO"          => $row['CDREGIAO_ORIGEM']
        );
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
    }
    
    public function getParamplaneja($row){
        $sql = "SELECT IDQTLIQUBRUT FROM PARAMPLANEJA WHERE CDFILIAL = :CDFILIAL AND NRORG = :NRORG";
        $params = array(
            "NRORG"         => $this->environment->getNrOrgTrab(),
            "CDFILIAL"      => $this->environment->getCdFilial()
        );
	    $query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $row['QTDRECEITA'] = empty($result[0]['IDQTLIQUBRUT']) ? "" : $result[0]['IDQTLIQUBRUT'];
        return $row;
    }
}